#######################################################################
#  This file is part of GNOWSYS: Gnowledge Networking and
#  Organizing System.
#
#  GNOWSYS is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as
#  published by the Free Software Foundation; either version 2 of
#  the License, or (at your option) any later version.
#
#  GNOWSYS is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public
#  License along with GNOWSYS (gpl.txt); if not, write to the 
#  Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
#  Boston, MA 02111-1307 USA.
#
######################################################################


import math
import cmath

def acos(x):
	"""
	complex
	Return the arc cosine of x. There are two branch cuts: One extends right from 1 along the real axis to ,
	continuous from below. The other extends left from -1 along the real axis to -, continuous from above. 
	"""
def acosh(x):
	"""    
	complex
	Return the hyperbolic arc cosine of x. There is one branch cut, extending left from 1 along the real axis to
	-, continuous from above. 
	"""
def asin(x):
	"""    
	complex
	Return the arc sine of x. This has the same branch cuts as acos(). 
	"""

def asinh(x):
	"""
	complex    
	Return the hyperbolic arc sine of x. There are two branch cuts, extending left from 1j to -j, both
	continuous from above. These branch cuts should be considered a bug to be corrected in a future release. The
	correct branch cuts should extend along the imaginary axis, one from 1j up to j and continuous from the right, and one from -1j down to -j and
	continuous from the left. 
	"""
def atan(x):
	"""
	complex
	Return the arc tangent of x. There are two branch cuts: One extends from 1j along the imaginary axis to j,
	continuous from the left. The other extends from -1j along the imaginary axis to -j, continuous from the left.
	(This should probably be changed so the upper cut becomes continuous from the other side.) 
	"""
def atanh(x):
	"""
	complex
	Return the hyperbolic arc tangent of x. There are two branch cuts: One extends from 1 along the real axis to
	, continuous from above. The other extends from -1 along the real axis to -, continuous from above. (This should probably be
	changed so the right cut becomes continuous from the other side.) 
	"""
def cos(x):
	"""    
	complex
	Return the cosine of x. 
	"""
def cosh(x):
	"""
	complex
	Return the hyperbolic cosine of x. 
	"""
def exp(x):
	"""    
	complex
	Return the exponential value e**x. 
	"""
def log(x):
	"""    
	complex
	Return the natural logarithm of x. There is one branch cut, from 0 along the negative real axis to -,
	continuous from above. 
	"""
def log10(x):
	"""
	complex
	Return the base-10 logarithm of x. This has the same branch cut as log(). 
	"""
def sin(x):
	"""
	complex
	Return the sine of x.
	"""
def sinh(x):
	"""
	complex
	Return the hyperbolic sine of x.
	"""
def sqrt(x):
	"""
	complex
	Return the square root of x. This has the same branch cut as log(). 
	"""
def tan(x):
	"""
	complex
	Return the tangent of x.
	"""
def tanh(x):
	"""
	complex
	Return the hyperbolic tangent of x.
	"""




