######################################################################
#  This file is part of GNOWSYS: Gnowledge Networking and
#  Organizing System.
#
#  GNOWSYS is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as
#  published by the Free Software Foundation; either version 2 of
#  the License, or (at your option) any later version.
#
#  GNOWSYS is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public
#  License along with GNOWSYS (gpl.txt); if not, write to the 
#  Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
#  Boston, MA 02111-1307 USA.
#
######################################################################

"called module"

from OFS import Folder
from AccessControl import User
from AccessControl import Role
from OFS.ObjectManager import ObjectManager
from Globals import InitializeClass, DTMLFile
import string

#assign some permission controls
ANONYMOUS_USER = ['Access contents information','View']
#GNOWSYS_User = ['Access contents information','Add Documents, Images, and Files','Add Folders','Can Login and Logout','Change DTML Documents','Change DTML Methods','Change Images and Files','Delete objects','Edit','FTP access','List folder contents','Manage Access Rules','Manage properties','Set own password','Set own properties','Take ownership','Undo changes','View','View History','View management screens','WebDAV access'] 
ACQUIRED = 0 # nothing is acquired from parent object.

class process_register:
    """ This class actually works only every aspect of product"""

    meta_type ="process_register"

    def __init__(self,login,password,confirm,fname,lname,email,place,phone,profession,expertise,homepage,details):
        try: #bug :(
            self.usertype = getattr(REQUEST,'usertype')
        except:
            self.usertype ='individual'
        
        #Login Details
        self.login = login
        self.__password = password
        self.__confirm = confirm
        
        #Personal Details
        if self.usertype == 'individual':
            self.fname = fname
            self.lname = lname
            self.email = email
            self.phone = phone
            self.place = place
            self.homepage = homepage
            self.profession = profession
            self.expertise = expertise
            self.details = details
        else: # itz organization
            self.email = email
            self.phone = phone
            self.homepage = homepage
            self.details = details

    def main(self,curr_obj):
        """ performs main operations """
                     
        #make userfolder and acl_user
	if not 'acl_users' in curr_obj.objectIds():
	   curr_obj.manage_addProduct['OFSP'].manage_addUserFolder() 
	acl_users = curr_obj.acl_users
	roles=['Guser']# or Owner or Manager .. Volunteer is our customerised role
	domain=''
	if hasattr(acl_users, '_addUser'):
           acl_users._addUser(self.login,self.__password,self.__confirm,roles,domain)
	        
        #put all members into 'Members' folder if this folder doesnot exsist create one
       # try:
	#    curr_obj=getattr(curr_obj,'Members')
        #except:
	 #   curr_obj.manage_addFolder('Members')
          #  curr_obj = getattr(curr_obj,'Members')
            
       	#make folder for user 
	#curr_obj.manage_addFolder(self.login)
	#curr_obj = getattr(curr_obj,self.login)
	
	#Play with itz permission
	#for permission_to_manage in curr_obj.possible_permissions():
         #   roles=['Manager','Owner'] # they get all the booty
          #  if permission_to_manage in ANONYMOUS_USER:
           #    roles.append('Anonymous')
            #if permission_to_manage in VOLUNTEER_USER:
               #roles.append('Volunteer')
           # curr_obj.manage_permission(permission_to_manage,roles,ACQUIRED)
        
	#modify metatype for this folder
	#self.modify_metatypes(curr_obj)
	
        #now add property to folder
	#self.add_property(curr_obj)
	
	homeURL=curr_obj.absolute_url()+"/zadding-users"
	return homeURL
		    
    def modify_metatypes(self,curr_obj,morelist=None):
        """ modify the metatypes for users """        
        allowedmetatypes = ('DTML Document','DTML Method','File','Folder','Image')
        if morelist != None:
           for moreMT in morelist:
               allowedmetatypes.append(moreMT)
        result = []
        import Products
        for metaType in Products.meta_types:
            if metaType['name'] in allowedmetatypes:
               result.append(metaType)
        curr_obj.all_meta_types = result
        return result

    def custom_changeOwnership(self,base, username=None, obj=None):
        """ explicitly setup changeOwnership for TTW """
        username = self.login
        acl_users = getattr(base, 'acl_users') #UserFolder source
        #obj = getattr(base,'Members')
        obj = getattr(obj,username)
        user = acl_users.getUser(username).__of__(acl_users)
        obj.changeOwnership(user)


    def add_property(self,curr_obj):
        """ make property sheet of users personal details """
       # if self.usertype == 'individual':
        #    curr_obj.manage_addProperty('fname', self.fname,'string')		
         #   curr_obj.manage_addProperty('lname', self.lname,'string')
          #  curr_obj.manage_addProperty('email', self.email,'string')
           # curr_obj.manage_addProperty('place',self.place,'string')            
            #curr_obj.manage_addProperty('phone', self.phone,'string')
           # curr_obj.manage_addProperty('profession', self.profession,'string')
            #curr_obj.manage_addProperty('expertise', self.expertise,'string')
          #  curr_obj.manage_addProperty('homepage', self.homepage,'string')
           # curr_obj.manage_addProperty('details', self.details,'string')
            #curr_obj.manage_addProperty('usertype', self.usertype,'string')
        #else: # organization	
          #  curr_obj.manage_addProperty('orgname', self.orgname,'string')		
           # curr_obj.manage_addProperty('contact', self.orgname,'string')		
           # curr_obj.manage_addProperty('address', self.address,'string')
           # curr_obj.manage_addProperty('email', self.email,'string')
           # curr_obj.manage_addProperty('phone', self.phone,'string')
           # curr_obj.manage_addProperty('working', self.working,'string')
           # curr_obj.manage_addProperty('homepage', self.homepage,'string')
           # curr_obj.manage_addProperty('details', self.details,'string')
           # curr_obj.manage_addProperty('usertype', self.usertype,'string')    




def adduser(self,login,password,confirm,fname,lname,email,place,phone,profession,expertise,homepage,details):
	""" Something  """
        runObj = process_register(login,password,confirm,fname,lname,email,place,phone,profession,expertise,homepage,details)
	if runObj.login in self.objectIds():
	     err_msg = 'Oops! Error Assingning Login,'+runObj.login+' This User Name is already taken,Try someother name'
	     return modified_return(self,err_msg,'./register','Re-Register')
        
        #self.passowrd=password
        #self.confirm=confirm
        #if password!=confirm:
             #err_msg1 = 'confirmation failed'
             
        
    #do everything
	userfolder = runObj.main(curr_obj=self)

    #change ownership
    #runObj.custom_changeOwnership(base=self)


    #now redirect
        a = runObj.login
        b = password
        c = fname
        d = lname
        e = email
        f = place
        g = phone
        h = profession
        i = expertise
        j = homepage
        k = details

        self.REQUEST.RESPONSE.redirect('zadding-users'+'?loginid=%s&pw=%s&cc=%s&dd=%s&ee=%s&ff=%s&gg=%s&hh=%s&ii=%s&jj=%s&kk=%s'%(a,b,c,d,e,f,g,h,i,j,k))


def modified_return(self,header,msg,url,button): # show error and also a return button
    wierd = "100% "
    return_str= """<dtml-var standard_html_header><table border="0" width=%s><tr><td width=%s bgcolor="0066FF">&nbsp;&nbsp; <font size="5">%s</font></td>
          </tr>
          <tr>
            <td width=%s>&nbsp;&nbsp;
              <p>%s</p>
              <p>&nbsp;</td>
          </tr>
          <tr>
            <td width=%s>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
              <form action = %s method="POST">
		<p align="center"><input type="submit" value=%s name="register"></p>
              </form>
            </td>
          </tr>
	</table>
	<dtml-var standard_html_footer> """ %(wierd,wierd,header,wierd,msg,wierd,url,button)
    return return_str


manage_addnewuserForm = DTMLFile('dtml/zregister',globals())


def verify_details(self,REQUEST=None):
    """Add New User object"""

    login=REQUEST['login']
    password=REQUEST['password']
    confirm=REQUEST['confirm']
    fname=REQUEST['fname']
    lname=REQUEST['lname']
    email=REQUEST['email']
    phone=REQUEST['phone']
    place=REQUEST['place']
    profession=REQUEST['profession']
    expertise=REQUEST['expertise']
    homepage=REQUEST['homepage']
    details=REQUEST['details']


    if password!=confirm:
      
      flag2=3
      flag=0
      flag1=0
      
      self.REQUEST.RESPONSE.redirect('zerrmsg?f=%s&f1=%s&f2=%s'%(flag,flag1,flag2))

      
      

    sp=['com','in','org','net','mil']
    c=REQUEST['email']
    d=list(c)

    if '@' not in d:
      flag2=1
      flag=0
      flag1=0
      self.REQUEST.RESPONSE.redirect('zerrmsg?f=%s&f1=%s&f2=%s'%(flag,flag1,flag2))
    else:
      flag2=0
    if '@' in d:
      e=string.split(c,'@')
      f=string.split(e[1],'.')
      l=len(f)
      l1=l-1
      g=string.split(f[1])

      if not e[0] or '.' not in list(e[1]) or not f[0] or not f[1] or f[l1] not in sp:
         flag=1
      else:
         flag=0   

    li=[48,49,50,51,52,53,54,55,56,57]
    a=REQUEST['phone']
    b = list(a)
    #print b

    for i in b:
     h=ord(i)
     if h not in li:
     #print 'not a valid phone no.'
         flag1=1
     else:
         flag1=0

     if flag or flag1 or flag2:
         self.REQUEST.RESPONSE.redirect('zerrmsg?f=%s&f1=%s&f2=%s'%(flag,flag1,flag2))
    else:
         adduser(self,login,password,confirm,fname,lname,email,place,phone,profession,expertise,homepage,details)
       
                    







